import type { SwiperControl, SwiperControlItem, SwiperGapSpace, SwiperInterface, SwiperItemsPerView, SwiperSlide } from './swiper.type';
export declare class SwiperUtil {
    private component;
    private currentRaf;
    private previousTransformValue;
    private active;
    id: string;
    containerId: string;
    containerEl?: HTMLElement;
    innerEl?: HTMLElement;
    borderEl?: HTMLElement;
    index: number;
    steps: number;
    noNeedForControls: boolean;
    isLastSlideVisible: boolean;
    itemsPerView: SwiperItemsPerView;
    controls: SwiperControl;
    gapSpace: SwiperGapSpace;
    /**
     * LIFECYCLE
     * ------------------------------------------------------
     */
    connectedCallback(component: SwiperInterface): void;
    disconnectedCallback(): void;
    /**
     * EVENTS
     * ------------------------------------------------------
     */
    private keyboardMode;
    private shiftMode;
    private isInsideContainer;
    private focusByKey;
    private pointerDown;
    private listenToKeyDown;
    /**
     * PUBLIC METHODS
     * ------------------------------------------------------
     */
    isActive(): boolean;
    activate(): Promise<void>;
    disable(): Promise<void>;
    focusItem(index: number): Promise<void>;
    focusNextItem(ev: KeyboardEvent): Promise<void>;
    focusPreviousItem(ev: KeyboardEvent): Promise<void>;
    /**
     * PRIVATE METHODS
     * ------------------------------------------------------
     */
    private updateFocus;
    private setFocusToEl;
    /**
     * CSS Classes
     * ------------------------------------------------------
     */
    private cssBlock;
    cssSwiper: () => {
        [x: string]: boolean;
    };
    cssInnerSwiper: () => {
        [x: string]: boolean;
    };
    cssSwiperContainer: () => {
        [x: string]: boolean;
    };
    /**
     * PUBLIC METHODS
     * ------------------------------------------------------
     */
    notifyChange: (...args: any[]) => any;
    isFirst(): boolean;
    hasShadowLeft(): boolean;
    hasShadowRight(): boolean;
    isLast(): boolean;
    previous(steps?: number): Promise<SwiperSlide | undefined>;
    next(steps?: number): Promise<SwiperSlide | undefined>;
    updateIndex(index?: number): Promise<undefined>;
    goTo(index?: number): Promise<SwiperSlide | undefined>;
    renderControls(): any;
    getAllControlItems(): SwiperControlItem[];
    onControlChange: (selectedValue: number) => void;
    /**
     * PRIVATE METHODS
     * ------------------------------------------------------
     */
    private lastIndex;
    private hasShadow;
    private notifyChangeInternal;
    private buildSlide;
    private animate;
    private onPreviousButtonClick;
    private onNextButtonClick;
}
